package cn.ibizlab.assetmanagement.core.apply.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.apply.domain.EAMApplyStateModel;
import cn.ibizlab.assetmanagement.core.apply.filter.EAMApplyStateModelSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMApplyStateModel] 服务对象接口
 */
public interface IEAMApplyStateModelService extends IService<EAMApplyStateModel>{

    boolean create(EAMApplyStateModel et) ;
    void createBatch(List<EAMApplyStateModel> list) ;
    boolean update(EAMApplyStateModel et) ;
    void updateBatch(List<EAMApplyStateModel> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMApplyStateModel get(String key) ;
    EAMApplyStateModel getDraft(EAMApplyStateModel et) ;
    boolean checkKey(EAMApplyStateModel et) ;
    boolean save(EAMApplyStateModel et) ;
    void saveBatch(List<EAMApplyStateModel> list) ;
    Page<EAMApplyStateModel> searchDefault(EAMApplyStateModelSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMApplyStateModel> getEamapplystatemodelByIds(List<String> ids) ;
    List<EAMApplyStateModel> getEamapplystatemodelByEntities(List<EAMApplyStateModel> entities) ;
}


